#include "descriptor/descriptor.h"

#include "basso.h"

int main() {
	
	ITEM metallo_chiaro,metallo_scuro,legno,nero_lucido;
	ITEM Fbase,base;
	ITEM Ffermo,FvtE,FvbE,FvtF,FvbF,FvtA,FvbA,FvtB,FvbB,fermo;
	ITEM Fmanico,Fpunta,Fponte,Fgiunto,manico;
	ITEM FrbE,Frm1E,Frm2E,FrtE,FriE;
	ITEM FrbF,Frm1F,Frm2F,FrtF,FriF;
	ITEM FrbA,Frm1A,Frm2A,FrtA,FriA;
	ITEM FrbB,Frm1B,Frm2B,FrtB,FriB,reg;
	ITEM FcE,FgE,FcF,FgF,FcA,FgA,FcB,FgB,corde;
	ITEM basso;

	/**** setup della scena ****/
	set_background(BG_R,BG_G,BG_B,BG_REF);
	set_ambient_light(AL_R,AL_G,AL_B,AL_INT);
	create_point_light(PL1_X,PL1_Y,PL1_Z,PL1_R,PL1_G,PL1_B,PL1_INT,PL1_RANGE,"luce_puntiforme_1");
	create_point_light(PL2_X,PL2_Y,PL2_Z,PL2_R,PL2_G,PL2_B,PL2_INT,PL2_RANGE,"luce_puntiforme_2");
	create_point_light(PL3_X,PL3_Y,PL3_Z,PL3_R,PL3_G,PL3_B,PL3_INT,PL3_RANGE,"luce_puntiforme_3");

	/**** attributi ****/
	/* metallo chiaro */
	metallo_chiaro = create_attribute("metallo_chiaro");
	set_color(metallo_chiaro,LM_R,LM_G,LM_B,LM_PA,LM_PD);
	set_reflectivity(metallo_chiaro,LM_PS,LM_PHONG);
	set_transparency(metallo_chiaro,LM_MAXT,LM_MINT,LM_TPWR,LM_N);

	/* metallo scuro */
	metallo_scuro = create_attribute("metallo_scuro");
	set_color(metallo_scuro,DM_R,DM_G,DM_B,DM_PA,DM_PD);
	set_reflectivity(metallo_scuro,DM_PS,DM_PHONG);
	set_transparency(metallo_scuro,DM_MAXT,DM_MINT,DM_TPWR,DM_N);

	/* legno */
	legno = create_attribute("legno");
	set_color(legno,W_R,W_G,W_B,W_PA,W_PD);
	set_reflectivity(legno,W_PS,W_PHONG);
	set_transparency(legno,W_MAXT,W_MINT,W_TPWR,W_N);

	/* nero lucido */
	nero_lucido = create_attribute("lucido_nero");
	set_color(nero_lucido,SB_R,SB_G,SB_B,SB_PA,SB_PD);
	set_reflectivity(nero_lucido,SB_PS,SB_PHONG);
	set_transparency(nero_lucido,SB_MAXT,SB_MINT,SB_TPWR,SB_N);

	/************ oggetti ************/
	/* base */
	Fbase = read_nurbs("base.db");
	set_attribute(Fbase,nero_lucido);
	base = create_list(Fbase,"base");

 /* fermo */
	// base del fermo
	Ffermo = read_nurbs("fermo.db");
	set_attribute(Ffermo,metallo_chiaro);
	fermo = create_list(Ffermo,"fermo");
	// vite per la corda E
	FvbE = read_nurbs("vbE.db");
	set_attribute(FvbE,metallo_chiaro);
	FvtE = read_nurbs("vtE.db");
	set_attribute(FvtE,metallo_scuro);
	fermo = insert_in_list(fermo,FvbE);
	fermo = insert_in_list(fermo,FvtE);
	// vite per la corda F
	FvbF = read_nurbs("vbF.db");
	set_attribute(FvbF,metallo_chiaro);
	FvtF = read_nurbs("vtF.db");
	set_attribute(FvtF,metallo_scuro);
	fermo = insert_in_list(fermo,FvbF);
	fermo = insert_in_list(fermo,FvtF);
	// vite per la corda A
	FvbA = read_nurbs("vbA.db");
	set_attribute(FvbA,metallo_chiaro);
	FvtA = read_nurbs("vtA.db");
	set_attribute(FvtA,metallo_scuro);
	fermo = insert_in_list(fermo,FvbA);
	fermo = insert_in_list(fermo,FvtA);
	// vite per la corda B
	FvbB = read_nurbs("vbB.db");
	set_attribute(FvbB,metallo_chiaro);
	FvtB = read_nurbs("vtB.db");
	set_attribute(FvtB,metallo_scuro);
	fermo = insert_in_list(fermo,FvbB);
	fermo = insert_in_list(fermo,FvtB);

	/* manico */
	Fmanico = read_nurbs("manico.db");
	set_attribute(Fmanico,legno);
	manico = create_list(Fmanico,"manico");
	Fponte = read_nurbs("ponte.db");
	set_attribute(Fponte,legno);
	manico = insert_in_list(manico,Fponte);
	Fgiunto = read_nurbs("giunto.db");
	set_attribute(Fgiunto,legno);
	manico = insert_in_list(manico,Fgiunto);
	Fpunta = read_nurbs("punta.db");
	set_attribute(Fpunta,nero_lucido);
	manico = insert_in_list(manico,Fpunta);

	/* regolazioni */
	// regolazioni per la corda E
	FrbE = read_nurbs("rbE.db");
	set_attribute(FrbE,metallo_chiaro);
	reg = create_list(FrbE,"regolazioni");
	Frm1E = read_nurbs("rm1E.db");
	set_attribute(Frm1E,metallo_chiaro);
	reg = insert_in_list(reg,Frm1E);
	Frm2E = read_nurbs("rm2E.db");
	set_attribute(Frm2E,metallo_chiaro);
	reg = insert_in_list(reg,Frm2E);
	FriE = read_nurbs("riE.db");
	set_attribute(FriE,metallo_scuro);
	reg = insert_in_list(reg,FriE);
	FrtE = read_nurbs("rtE.db");
	set_attribute(FrtE,metallo_scuro);
	reg = insert_in_list(reg,FrtE);
	// regolazioni per la corda F
	FrbF = read_nurbs("rbF.db");
	set_attribute(FrbF,metallo_chiaro);
	reg = insert_in_list(reg,FrbF);
	Frm1F = read_nurbs("rm1F.db");
	set_attribute(Frm1F,metallo_chiaro);
	reg = insert_in_list(reg,Frm1F);
	Frm2F = read_nurbs("rm2F.db");
	set_attribute(Frm2F,metallo_chiaro);
	reg = insert_in_list(reg,Frm2F);
	FriF = read_nurbs("riF.db");
	set_attribute(FriF,metallo_scuro);
	reg = insert_in_list(reg,FriF);
	FrtF = read_nurbs("rtF.db");
	set_attribute(FrtF,metallo_scuro);
	reg = insert_in_list(reg,FrtF);
	// regolazioni per la corda A
	FrbA = read_nurbs("rbA.db");
	set_attribute(FrbA,metallo_chiaro);
	reg = insert_in_list(reg,FrbA);
	Frm1A = read_nurbs("rm1A.db");
	set_attribute(Frm1A,metallo_chiaro);
	reg = insert_in_list(reg,Frm1A);
	Frm2A = read_nurbs("rm2A.db");
	set_attribute(Frm2A,metallo_chiaro);
	reg = insert_in_list(reg,Frm2A);
	FriA = read_nurbs("riA.db");
	set_attribute(FriA,metallo_scuro);
	reg = insert_in_list(reg,FriA);
	FrtA = read_nurbs("rtA.db");
	set_attribute(FrtA,metallo_scuro);
	reg = insert_in_list(reg,FrtA);
	// regolazioni per la corda B
	FrbB = read_nurbs("rbB.db");
	set_attribute(FrbB,metallo_chiaro);
	reg = insert_in_list(reg,FrbB);
	Frm1B = read_nurbs("rm1B.db");
	set_attribute(Frm1B,metallo_chiaro);
	reg = insert_in_list(reg,Frm1B);
	Frm2B = read_nurbs("rm2B.db");
	set_attribute(Frm2A,metallo_chiaro);
	reg = insert_in_list(reg,Frm2B);
	FriB = read_nurbs("riB.db");
	set_attribute(FriB,metallo_scuro);
	reg = insert_in_list(reg,FriB);
	FrtB = read_nurbs("rtB.db");
	set_attribute(FrtB,metallo_scuro);
	reg = insert_in_list(reg,FrtB);

	/* corde */
	// corda E
	FcE = read_nurbs("cE.db");
	set_attribute(FcE,metallo_chiaro);
	corde = create_list(FcE,"corde");
	FgE = read_nurbs("gE.db");
	set_attribute(FgE,metallo_chiaro);
	corde = insert_in_list(corde,FgE);
	// corda F
	FcF = read_nurbs("cF.db");
	set_attribute(FcF,metallo_chiaro);
	corde = insert_in_list(corde,FcF);
	FgF = read_nurbs("gF.db");
	set_attribute(FgF,metallo_chiaro);
	corde = insert_in_list(corde,FgF);
	// corda A
	FcA = read_nurbs("cA.db");
	set_attribute(FcA,metallo_chiaro);
	corde = insert_in_list(corde,FcA);
	FgA = read_nurbs("gA.db");
	set_attribute(FgA,metallo_chiaro);
	corde = insert_in_list(corde,FgA);
	// corda B
	FcB = read_nurbs("cB.db");
	set_attribute(FcB,metallo_chiaro);
	corde = insert_in_list(corde,FcB);
	FgB = read_nurbs("gB.db");
	set_attribute(FgB,metallo_chiaro);
	corde = insert_in_list(corde,FgB);

	/**** creazione del basso ****/
	basso = create_list(base,"basso");
	basso = insert_in_list(basso,fermo);
	basso = insert_in_list(basso,manico);
	basso = insert_in_list(basso,reg);
	basso = insert_in_list(basso,corde);

	/**** salvataggio della scena finale ****/
	save_scene("basso.md","basso",basso);

	return(0);
}
